## dlpack 0.0~git20200217.3ec0443

=== CMakeLists.txt ===
###
# Set minimum version of CMake. Since command 'project' use
# VERSION sub-option we need at least 3.0.
# Note: If you use 2.6 or 2.4, God kills a kitten. Seriously.
cmake_minimum_required(VERSION 3.2 FATAL_ERROR)

####
# Set variables:
#   * PROJECT_NAME
#   * PROJECT_VERSION
project(dlpack VERSION 0.1.0 LANGUAGES C CXX)

#####
# Change the default build type from Debug to Release, while still
# supporting overriding the build type.
#
# The CACHE STRING logic here and elsewhere is needed to force CMake
# to pay attention to the value of these variables.
if(NOT CMAKE_BUILD_TYPE)
    message(STATUS "No build type specified; defaulting to CMAKE_BUILD_TYPE=Release.")
    set(CMAKE_BUILD_TYPE Release CACHE STRING
        "Choose the type of build, options are: None Debug Release RelWithDebInfo MinSizeRel."
        FORCE)
else(NOT CMAKE_BUILD_TYPE)
    if(CMAKE_BUILD_TYPE STREQUAL "Debug")
        message("==========================================================================================")
        message(STATUS "Build type: Debug. Performance will be terrible!")
        message(STATUS "Add -DCMAKE_BUILD_TYPE=Release to the CMake command line to get an optimized build.")
        message("==========================================================================================")
    endif(CMAKE_BUILD_TYPE STREQUAL "Debug")
endif(NOT CMAKE_BUILD_TYPE)

####
# Setup the compiler options

# set c++ standard to c++11.
# Note: not working on CMake 2.8. We assume that user has
#       a compiler with C++11 support.

set(CMAKE_CXX_STANDARD 11)
set(CMAKE_CXX_STANDARD_REQUIRED ON)
message(STATUS "C++11 support has been enabled by default.")

option(BUILD_DOCS "Set to ON to build documentation" OFF)
option(BUILD_MOCK "Build mock executable" ON)

if(BUILD_DOCS)
    add_subdirectory(docs)
endif(BUILD_DOCS)

set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${PROJECT_SOURCE_DIR}/bin)

if(BUILD_MOCK)
  set(DLPACK_MOCK_SRCS ${CMAKE_CURRENT_SOURCE_DIR}/contrib/mock_main.cc
                      ${CMAKE_CURRENT_SOURCE_DIR}/contrib/mock_c.c)
  add_executable(mock ${DLPACK_MOCK_SRCS})
endif()

add_library(dlpack INTERFACE)
add_library(${PROJECT_NAME}::dlpack ALIAS dlpack)

target_include_directories(
    dlpack
    INTERFACE
    $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>
    $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/contrib>
)

if(BUILD_MOCK)
  target_link_libraries(mock PRIVATE dlpack)
endif()

# Installation (https://github.com/forexample/package-example) {

# Introduce variables:
# * CMAKE_INSTALL_LIBDIR
# * CMAKE_INSTALL_BINDIR
# * CMAKE_INSTALL_INCLUDEDIR
include(GNUInstallDirs)

set(config_install_dir "${CMAKE_INSTALL_LIBDIR}/cmake/${PROJECT_NAME}")
set(generated_dir "${CMAKE_CURRENT_BINARY_DIR}/generated")
set(version_config "${generated_dir}/${PROJECT_NAME}ConfigVersion.cmake")
set(project_config "${generated_dir}/${PROJECT_NAME}Config.cmake")
set(TARGETS_EXPORT_NAME "${PROJECT_NAME}Targets")
set(namespace "${PROJECT_NAME}::")

include(CMakePackageConfigHelpers)

# Use:
# * PROJECT_VERSION
write_basic_package_version_file(
    "${version_config}" COMPATIBILITY SameMajorVersion
)

# Use:
#   * TARGETS_EXPORT_NAME
#   * PROJECT_NAME
configure_package_config_file(
    "cmake/template/Config.cmake.in"
    "${project_config}"
    INSTALL_DESTINATION "${config_install_dir}"
)

install(
    TARGETS dlpack
    EXPORT "${TARGETS_EXPORT_NAME}"
    INCLUDES DESTINATION "${CMAKE_INSTALL_INCLUDEDIR}"
)

install(
    DIRECTORY include/
    DESTINATION "${CMAKE_INSTALL_INCLUDEDIR}"
)

install(
    FILES "${project_config}" "${version_config}"
    DESTINATION "${config_install_dir}"
)

install(
    EXPORT "${TARGETS_EXPORT_NAME}"
    NAMESPACE "${namespace}"
    DESTINATION "${config_install_dir}"
)

# }

=== docs/CMakeLists.txt ===
find_package(Doxygen QUIET)
if(NOT DOXYGEN_FOUND)
    message(FATAL_ERROR "Doxygen is needed to build the documentation.")
endif()

# TODO: add config file
set(doxyfile_in ${CMAKE_CURRENT_SOURCE_DIR}/Doxyfile.in)
set(doxyfile    ${CMAKE_CURRENT_BINARY_DIR}/Doxyfile)

configure_file(${doxyfile_in} ${doxyfile} @ONLY)

add_custom_target(docs
    COMMAND ${DOXYGEN_EXECUTABLE} ${doxyfile}
    WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
    COMMENT "Generating API documentation with Doxygen"
    VERBATIM)

install(DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/html DESTINATION share/${PROJECT_NAME}/docs)

=== debian/changelog ===
dlpack (0.0~git20200217.3ec0443-2) unstable; urgency=medium

  * Bump debhelper compat level to 13.
  * Apply wrap-and-sort.
  * Upload to unstable.

 -- Mo Zhou <lumin@debian.org>  Sun, 14 Jun 2020 21:01:35 +0800

dlpack (0.0~git20200217.3ec0443-1) experimental; urgency=medium

  * Initial release. (Closes: #951205)

 -- Mo Zhou <lumin@debian.org>  Sun, 19 Apr 2020 19:14:13 +0800

=== debian/watch ===
version=4
opts="mode=git, pgpmode=none" \
https://github.com/dmlc/dlpack \
HEAD debian uupdate

## dlpack 0.6

=== Makefile ===
.PHONY: clean all test doc lint

all: bin/mock

LDFLAGS =
CFLAGS = -Wall -O3 -Iinclude -Icontrib
CXXFLAGS = -std=c++11 $(CFLAGS)

SRC = $(wildcard contrib/*.cc contrib/*.c)
ALL_CXX_OBJ = $(patsubst contrib/%.cc, build/%.o, $(SRC))
ALL_C_OBJ = $(patsubst contrib/%.c, build/%.o, $(SRC))
ALL_OBJ = $(ALL_CC_OBJ) $(ALL_CXX_OBJ)

doc:
	doxygen docs/Doxyfile

lint:
	./tests/scripts/task_lint.sh

build/%.o: contrib/%.cc
	@mkdir -p $(@D)
	$(CXX) $(CXXFLAGS) -MM -MT build/$*.o $< >build/$*.d
	$(CXX) -c $(CXXFLAGS) -c $< -o $@

build/%.o: contrib/%.c
	@mkdir -p $(@D)
	$(CC) $(CFLAGS) -MM -MT build/$*.o $< >build/$*.d
	$(CC) -c $(CFLAGS) -c $< -o $@

bin/mock: $(ALL_OBJ)
	@mkdir -p $(@D)
	$(CXX) $(CXXFLAGS) -o $@ $(filter %.o %.a, $^) $(LDFLAGS)

clean:
	$(RM) -rf build  */*/*/*~ */*.o */*/*.o */*/*/*.o */*.d */*/*.d */*/*/*.d

=== apps/from_numpy/Makefile ===
all: numpy_dlpack.c
	gcc -I../../include -shared -o libmain.so -fPIC numpy_dlpack.c

=== debian/changelog ===
dlpack (0.6-1) unstable; urgency=medium

  * New upstream release.
  * Update watch file for real releases

 -- Wookey <wookey@debian.org>  Thu, 20 Jan 2022 04:55:20 +0000

=== debian/control ===
Source: dlpack
Section: science
Homepage: https://github.com/dmlc/dlpack
Priority: optional
Standards-Version: 4.5.0
Vcs-Git: https://salsa.debian.org/deeplearning-team/dlpack.git
Vcs-Browser: https://salsa.debian.org/deeplearning-team/dlpack
Maintainer: Debian Deep Learning Team <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Mo Zhou <lumin@debian.org>
Build-Depends: cmake, debhelper-compat (= 13)
Rules-Requires-Root: no

Package: libdlpack-dev
Architecture: any
Depends: ${misc:Depends}
Description: Open In Memory Tensor Structure
 DLPack is an open in-memory tensor structure to for sharing tensor among
 frameworks. DLPack enables
 .
  * Easier sharing of operators between deep learning frameworks.
  * Easier wrapping of vendor level operator implementations, allowing
    collaboration when introducing new devices/ops.
  * Quick swapping of backend implementations, like different version of BLAS
  * For final users, this could bring more operators, and possibility of mixing
    usage between frameworks.
 .
 DLPack do not intend to implement of Tensor and Ops, but instead use this as
 common bridge to reuse tensor and ops across frameworks.

=== debian/watch ===
version=4

opts=filenamemangle=s/.+\/v?(\d\S+)\.tar\.gz/dlpack-$1\.tar\.gz/ \
  https://github.com/dmlc/dlpack/tags .*/v?(\d\S+)\.tar\.gz debian uupdate

## dlpack 1.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -8,7 +8,7 @@
 # Set variables:
 #   * PROJECT_NAME
 #   * PROJECT_VERSION
-project(dlpack VERSION 0.1.0 LANGUAGES C CXX)
+project(dlpack VERSION 0.6 LANGUAGES C CXX)
 
 #####
 # Change the default build type from Debug to Release, while still

=== docs/CMakeLists.txt ===
find_package(Doxygen QUIET)
if(NOT DOXYGEN_FOUND)
    message(FATAL_ERROR "Doxygen is needed to build the documentation.")
endif()

# TODO: add config file
set(doxyfile_in ${CMAKE_CURRENT_SOURCE_DIR}/Doxyfile.in)
set(doxyfile    ${CMAKE_CURRENT_BINARY_DIR}/Doxyfile)
set(doxygen_output_dir ${CMAKE_CURRENT_BINARY_DIR}/doxygen)

configure_file(${doxyfile_in} ${doxyfile} @ONLY)

file(MAKE_DIRECTORY ${doxygen_output_dir})

add_custom_target(Doxygen ALL
    COMMAND ${DOXYGEN_EXECUTABLE} ${doxyfile}
    WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
    COMMENT "Generating API documentation with Doxygen"
    VERBATIM)

find_program(SPHINX_EXECUTABLE
    NAMES sphinx-build
    DOC "Path to sphinx-build executable")

set(sphinx_source ${CMAKE_CURRENT_SOURCE_DIR}/source)
set(sphinx_build ${CMAKE_CURRENT_BINARY_DIR}/build/latest)
set(doxygen_xml_builddir ${doxygen_output_dir}/xml)

add_custom_target(Sphinx ALL
    COMMAND ${SPHINX_EXECUTABLE} -b html
    -Dbreathe_projects.dlpack=${doxygen_xml_builddir}
    ${sphinx_source} ${sphinx_build} -WT --keep-going
    WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
    COMMENT "Generating documentation with Sphinx"
    VERBATIM)

install(DIRECTORY ${sphinx_build} DESTINATION share/${PROJECT_NAME}/docs)

=== debian/changelog ===
dlpack (1.0-2) unstable; urgency=medium

  * Team upload.
  * Bump CMake policy version (Closes: #1112850)

 -- Timo Röhling <roehling@debian.org>  Sat, 27 Sep 2025 22:14:17 +0200

dlpack (1.0-1) unstable; urgency=medium

  [ Debian Janitor ]
  * Set upstream metadata fields: Repository-Browse.
  * Update standards version to 4.6.2, no changes needed.
  * Apply multi-arch hints. + libdlpack-dev: Add Multi-Arch: same.

  [ Mo Zhou ]
  * New upstream version 1.0
  * Update watch file.

 -- Mo Zhou <lumin@debian.org>  Sun, 13 Oct 2024 17:30:19 -0400

=== debian/control ===
--- 
+++ 
@@ -2,7 +2,7 @@
 Section: science
 Homepage: https://github.com/dmlc/dlpack
 Priority: optional
-Standards-Version: 4.5.0
+Standards-Version: 4.6.2
 Vcs-Git: https://salsa.debian.org/deeplearning-team/dlpack.git
 Vcs-Browser: https://salsa.debian.org/deeplearning-team/dlpack
 Maintainer: Debian Deep Learning Team <debian-science-maintainers@lists.alioth.debian.org>
@@ -13,6 +13,7 @@
 Package: libdlpack-dev
 Architecture: any
 Depends: ${misc:Depends}
+Multi-Arch: same
 Description: Open In Memory Tensor Structure
  DLPack is an open in-memory tensor structure to for sharing tensor among
  frameworks. DLPack enables

=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@ -Scmake

override_dh_auto_configure:
	dh_auto_configure -Scmake -- -DCMAKE_POLICY_VERSION_MINIMUM=3.10

=== debian/watch ===
version=4
opts="filenamemangle=s%(?:.*?)?v?@ANY_VERSION@(@ARCHIVE_EXT@)%@PACKAGE@-$1$2%" \
https://github.com/dmlc/dlpack/tags \
(?:.*?/)?v?@ANY_VERSION@@ARCHIVE_EXT@
